/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2004 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
 *
 * TODO:
 *  o Implement select(2) for portability purposes
 *  o Implement kqueue(2)
*/
#include <firestorm.h>
#include <dotscara/fdctl.h>
#include <plugin.h>
#include <nbio.h>

#if HAVE_POLL
#include "poll.c"
#endif
#if HAVE_EPOLL_CREATE
#include "epoll.c"
#endif

struct eventloop firestorm_eventloops[]={
#if HAVE_POLL
	{
		.name = "poll",
		.init = poll_init,
		.fini = poll_fini,
		.inactive = poll_inactive,
		.active = poll_active,
		.pump = poll_pump,
	},
#endif
#if HAVE_EPOLL_CREATE
	{
		.name = "epoll",
		.init = epoll_init,
		.fini = epoll_fini,
		.inactive = epoll_inactive,
		.active = epoll_active,
		.pump = epoll_pump,
	},
#endif
	{.name = NULL}
};

struct plugin_desc firestorm_plugin_desc = {
	.size		= sizeof(firestorm_plugin_desc),
	.name		= "eventloop.poll",
	.desc		= "Eventloop Mechanisms",
	.author_name	= "Gianni Tedesco",
	.author_email	= "gianni@scaramanga.co.uk",
	.ver_major	= 0,
	.ver_minor	= 1,
};
