" Vim syntax file
" Language:	Firestorm config file
" Maintainer:	Gianni Tedesco <gianni@scaramanga.co.uk>
" Last Change:	$Id: firestorm.vim 570 2004-07-24 21:20:12Z scara $

" Quit when a syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

" File name
syn match	firestormAction	"firestorm\.conf"

" firestorm.conf syntax is case sensitive
syn case match

" Comment stuff
syn keyword	firestormTodo		contained TODO
syn keyword	firestormIndoc		contained SYNOPSIS SYNTAX NOTES
syn match	firestormComment	"#.*$" contains=firestormTodo,firestormIndoc

" General variables etc..
syn match	firestormBool	"\<yes\>"
syn match	firestormBool	"\<no\>"
syn match	firestormNumber	"\<\d\+\>"
syn match	firestormIP	"\<\d\{1,3}\.\d\{1,3}\.\d\{1,3}\.\d\{1,3}\>"
syn match	firestormVer	"\<\d\+\>\.\<\d\+\>"

" Generic keywords
syn keyword	firestormConf	load_plugins load_plugin require
syn keyword	firestormConf	firestorm_root chroot realtime
syn keyword	firestormConf	effective_uid effective_gid effective_user
syn keyword	firestormConf	logfile

syn match fCapStart skipwhite "^capture\s" nextgroup=fCapType skipwhite
syn region  fCapType contained oneline start="." end="\s"he=s-1 nextgroup=fCapF skipwhite
syn region  fCapF contained oneline start="." end="$" keepend skipwhite
hi def link fCapstart	Keyword
hi def link fCapType	Type

" Signatures
syn match fSigStart skipwhite "^signatures\s" nextgroup=fCapType skipwhite
hi def link fSigStart Keyword

" Preprocessors
syn match fPreStart skipwhite "^preprocessor\s" nextgroup=fCapType skipwhite
hi def link fPreStart Keyword

" Output directory
syn match fOutStart skipwhite "^output\s" nextgroup=fCapType skipwhite
hi def link fOutStart Keyword

" The default highlighting.
hi def link firestormTodo		Todo
hi def link firestormIndoc		Function
hi def link firestormComment		Comment
hi def link firestormAction		String
hi def link firestormNumber		Number
hi def link firestormBool		Number
hi def link firestormIP			Number
hi def link firestormVer		Number
hi def link firestormConf		Keyword

let b:current_syntax = "firestorm"

" vim: ts=8
