/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __DETECT_HEADER_INCLUDED__
#define __DETECT_HEADER_INCLUDED__

struct detect {
	struct detect *next;
	struct matcher *type;
	void (*match)(struct detect *d, struct packet *p, int l);
	struct detect *any;
	/* ... private data ... */
};

struct detect_root {
	struct detect *child;
};

struct sig_node {
	void *private;
	int negate;
	struct alert *alert;
	struct matcher *match;
};

struct sig_node *detect_new_sig(struct rule *r, const char **ignore);
int detect_add_sig(struct detect_root *r, struct sig_node *sig,
			unsigned int len, struct alert *alert) __nonull(1,2,4);
void detect_free_sig(struct sig_node *sig, unsigned int n) __nonull(1);
int detect_optimize(void);
void detect(struct detect_root *r, struct packet *p, int l) __nonull(1,2);

#endif /* __DETECT_HEADER_INCLUDED__ */
