/*
 * This file is part of dotscara
 * Copyright (c) 2003 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
 */
#ifndef __FLBUF_HEADER_INCLUDED__
#define __FLBUF_HEADER_INCLUDED__

typedef int (*flbuf_cbfn_t)(void *priv, u_int8_t *buf,
				size_t line, size_t len);

struct flbuf {
	/* [ Do not change these fields, they are ABI ] */
	int fd;
	void *priv;

	u_int8_t *buf;
	size_t buf_sz;
	size_t max_sz;
	flbuf_cbfn_t cbfn;
	flbuf_cbfn_t cbfn2;
};

int __public flbuf_attach(struct flbuf *b, int fd, size_t max_sz,
				flbuf_cbfn_t cbfn, flbuf_cbfn_t cbfn2,
				void *priv) __nonull(1);
void __public flbuf_detach(struct flbuf *b) __nonull(1);
void __public flbuf_close(struct flbuf *b) __nonull(1);
void __public flbuf_newfd(struct flbuf *b, int fd) __nonull(1);
int __public flbuf_read(struct flbuf *b) __nonull(1);
static inline void *flbuf_private(struct flbuf *b) __nonull(1);
static inline int flbuf_fd(struct flbuf *b) __nonull(1);

static inline void *flbuf_private(struct flbuf *b)
{
	return b->priv;
}

static inline int flbuf_fd(struct flbuf *b)
{
	return b->fd;
}

#endif /* __FLBUF_HEADER_INCLUDED__ */
