/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __ELOG_READ_HEADER_INCLUDED__
#define __ELOG_READ_HEADER_INCLUDED__

struct elog_pkt {
	struct elog *file;
	struct elog_pkthdr *hdr;
	char *decode_buf;
	char *data;
	char *generator;
	char *alert;
	size_t ofs;
};

typedef int(*proc_elogfn)(struct elog_pkt *, void *);

struct elog {
	char *map, *end;
	int fd;
	size_t maplen;
	proc_elogfn dispatch;
};

struct elog *elog_new(int);
void elog_free(struct elog *) __nonull(1);
int elog_run(struct elog *, void *) __nonull(1);
size_t elog_pkt(struct elog *, size_t, void *) __nonull(1);
proc_elogfn elog_set_alert_fn(struct elog *, proc_elogfn) __nonull(1);

#endif /* __ELOG_READ_HEADER_INCLUDED__ */
